/*
 * AXIS.H: definitions for axis routines.
 */
#ifndef _axis_h
#define _axis_h
/*
 * XAXISVAR, YAXISVAR: collected parameters for x, y axies.
 */

struct axisvars {
    int ndig;			/* max no. of digits after dec. pnt. */
    real tikup, tikdn;		/* axis tickmark params: plus and minus */
    real numdn, sznum;		/* tick-value positioning and size params */
    real labdn, szlab;		/* label positioning and size params */
};

extern struct axisvars xaxisvar;
extern struct axisvars yaxisvar;

/*
 * FORMALAXIS: if TRUE, draw axies in formal style.
 */

extern bool formalaxis;

#if 0
extern void xaxis ARGS((real, real, real, real *, int, rproc, string));
extern void yaxis ARGS((real, real, real, real *, int, rproc, string));
extern void axvar ARGS((real, real, real));
extern void xaxvar ARGS((int, real, real, real, real));
extern void yaxvar ARGS((int, real, real, real, real));
#endif



#endif


/* axis.c */
extern void xaxis ARGS((real x0, real y0, real xl, real tick[], int nticks, rproc xtrans, string label));
extern void yaxis ARGS((real x0, real y0, real yl, real tick[], int nticks, rproc ytrans, string label));
extern void axvar ARGS((real sn, real sl, real scale));
extern void xaxvar ARGS((int nxd, real xtu, real xtd, real xnd, real xld));
extern void yaxvar ARGS((int nyd, real ytr, real ytl, real ynl, real yll));
