/*
 * FILESTRUCT.H: user definitions for filestruct routines.
 *	4-mar-91  added copy_item_cvt		PJT
 *	6-may-92  random data access routines	PJT
 *     21-feb-94  ansi                          pjt
 */
#ifndef _filestruct_h
#define _filestruct_h
/*
 * New-style basic item types.
 */

#define AnyType    "a"       /* anything at all */
#define CharType   "c"       /* printable chars */
#define ByteType   "b"       /* unprintable chars */
#define ShortType  "s"       /* short integers */
#define IntType    "i"       /* standard integers */
#define LongType   "l"       /* long integers */
#define FloatType  "f"       /* short floating */
#define DoubleType "d"       /* long floating */
#define SetType    "("       /* begin compound item */
#define TesType    ")"       /* end of compound item */
/* Experimental Kludge */
#define StoryType  "["       /* begin of a story item (see starlab) */
#define YrotsType  "]"       /* end of a story item (see starlab) */
/*
 * MaxTagLen, MaxVecDim, MaxSetLen: arbitrary storage limits. These may be
 * increased as necessary without rendering old data files obsolete.
 */

#define MaxTagLen  65		/* max tag length, limited for simplicity */
#define MaxVecDim   9		/* max num of vec dim, limited for safety */
#define MaxSetLen  65		/* max num of components in compound item */

/*
 * For the benefit of applications programs which include this file,
 * define standard synonyms for bools and reals (see stdinc.h).
 */

#define BoolType ShortType

#ifndef SINGLEPREC
#  define RealType DoubleType
#else
#  define RealType FloatType
#endif

#ifndef HeadlineTag
#  define HeadlineTag "Headline"
#endif

/*
 * Publically accessible routines.
 */

extern void copy_item ARGS((stream, stream, string));
extern void copy_item_cvt ARGS((stream, stream, string, string *));

extern void put_set ARGS((stream, string));
extern void put_tes ARGS((stream, string));
extern void put_string ARGS(( stream, string , string ));
extern void put_data ARGS(( stream, string, string, void *, int, ...));
extern void put_data_sub ARGS(( stream, string, string, void *, int *, bool));

extern void get_set ARGS(( stream str, string tag ));
extern void get_tes ARGS(( stream str, string tag ));
extern string get_string ARGS(( stream str, string tag ));
extern void get_data ARGS(( stream, string, string, void *, int, ...));

extern void get_data_coerced ARGS(( stream, string, string, void *, int, ...));
			 
extern void get_data_sub ARGS(( stream, string, string, void *, int *, bool));
		     
extern bool get_tag_ok ARGS(( stream, string));
extern bool skip_item ARGS(( stream));
extern string *list_tags ARGS(( stream));
extern string get_type ARGS(( stream, string));
extern int *get_dims ARGS(( stream, string));
extern int get_dlen ARGS(( stream, string));

extern void strclose ARGS(( stream));

extern void get_data_set ARGS(( stream , string , string , int,  ...));
extern void get_data_tes ARGS(( stream , string  ));
extern void get_data_ran ARGS(( stream , string , void *, int , int ));

extern void put_data_set ARGS(( stream , string , string , int,  ...));
		
extern void put_data_tes ARGS(( stream , string ));
extern void put_data_ran ARGS(( stream , string , void *, int , int  ));

extern bool qsf ARGS(( stream ));
#endif
