/*
 * GETPARAM.H: command-line processing definitions
 *
 * Mar. 1987  Joshua Edward Barnes, Princeton NJ.
 * Sep. 1990  -- added finiparam() to list              PJT
 * Nov. 1991  -- added hasvalue()                       PJT
 * July 1993 -- C++ entrant
 * Mar  1994 -- added nemoinpf/r
 */

#ifndef _getparam_h
#define _getparam_h
#ifdef __cplusplus
extern "C" {
#endif	
void    initparam ARGS((string *, string *));
void    finiparam ARGS((void));
void    stop ARGS(( int ));
void	putparam ARGS(( string, string));
void	promptparam ARGS(( string, string));
bool    isaparam ARGS(( string));
bool    hasvalue ARGS(( string));
string  getparam ARGS(( string));
int     getiparam ARGS(( string));
long    getlparam ARGS(( string));
bool    getbparam ARGS(( string));
double  getdparam ARGS(( string));

int nemoinpi ARGS((string, int *, int));
int nemoinpd ARGS((string, double *, int));
int nemoinpf ARGS((string, float *, int));
int nemoinpl ARGS((string, long *, int));
int nemoinpb ARGS((string, bool *, int));
#if !defined(SINGLEPREC)
# define nemoinpr nemoinpd
#else
# define nemoinpr nemoinpf
#endif

#ifdef __cplusplus
}
#endif

/*
 * Macro used to obtain name of program.
 */

#define getargv0()      (getparam("argv0"))
#endif /* _getparam_h */
