/*  burststring, freestrings, splitstring(not tested!!!)
 *
 * BURSTSTRING: break a string of the form "word1, word2, ..." into
 * seperate strings "word1", "word2", ... and return them in an
 * extended-string (ie, NULL-terminated sequence of pointers).
 */

#include <stdinc.h>
#include <string.h>
#include <extstring.h>

#define MWRD 512	/* max words in list */
#define MSTR  64	/* max chars per word */

string *burststring(lst, sep)
string lst;		/* list of words to seperate */
string sep;		/* chars which seperate words */
{
    string wrdbuf[MWRD], *wp;
    char strbuf[MSTR], *sp, *lp;

    wp = wrdbuf;
    sp = strbuf;
    lp = lst;
    do {						/* scan over list */
	if (*lp == NULL || strchr(sep, *lp) != NULL) {	/*   is this a sep? */
	    if (sp > strbuf) {				/*     got a word? */
		*sp = NULL;
		*wp++ = (string) copxstr(strbuf, sizeof(char));
		if (wp == &wrdbuf[MWRD])		/*       no room? */
		    error("burststring: too many words\n");
		sp = strbuf;				/*       for next 1 */
	    }
	} else {					/*   part of word */
	    *sp++ = *lp;				/*     so copy it */
	    if (sp == &strbuf[MSTR])			/*     no room? */
		error("burststring: word too long\n");
	}
    } while (*lp++ != NULL);				/* until list ends */
    *wp = NULL;
    return ((string *) copxstr((char *)wrdbuf, sizeof(string)));	/*PPAP*/
}

void freestrings(strptr)              /* free a previously allocated  */
string *strptr;                    /* array of strings */
{
    string *s;

    for (s=strptr; *s != NULL; s++)             /* loop over all strings */
        free(*s);                               /* free each one */
    free(strptr);                               /* and free the 'parent' */
}


int splitstring(maxout, out, lst, sep)
int maxout;		/* declared length of out[] array */
string out[];		/* array for pointers to words that remain in lst */
string lst;		/* list of words to patch and seperate */
string sep;		/* chars which seperate words */
{
    string wrdbuf[MWRD], *wp;
    char strbuf[MSTR], *sp, *lp;

    wp = out;	/* point to first word */
    sp = lst;	/* point to first char */
    lp = lst;
    do {						/* scan over list */
	if (*lp == NULL || strchr(sep, *lp) != NULL) {	/*   is this a sep? */
	    if (sp > strbuf) {				/*     got a word? */
		*sp = NULL;
                *wp++ = 
		*wp++ = (string) copxstr(strbuf, sizeof(char));
		if (wp == &wrdbuf[MWRD])		/*       no room? */
		    error("burststring: too many words\n");
		sp = strbuf;				/*       for next 1 */
	    }
	} 
    } while (*lp++ != NULL);				/* until list ends */

    return wp-out;
}


#ifdef TESTBED

#include <getparam.h>

string defv[] = {
    "lst=foo, bar,waldo ,",
    "sep= ,",
    NULL,
};

nemo_main()
{
    string lst, sep, *wrds;

    lst = getparam("lst");
    sep = getparam("sep");
    wrds = burststring(lst, sep);
    while (*wrds != NULL)
	printf("\"%s\"  ", *wrds++);
    printf("\n");
    freestrings(wrds);

    
}
#endif
