/*
 * SCANOPT: scan string of the form "word1,word2,..." for match. Warning:
 * words must be separated by exactly one comma -- no spaces allowed!
 */

#include <stdinc.h>

bool scanopt(opt, key)
string opt;		/* string of options */
string key;		/* keyword to scan for */
{
    char *op, *kp;

    op = (char *) opt;				/* start scan of options */
    while (*op != NULL) {			/* loop over words */
	kp = key;
#if defined(aix1)
	while ((*op != ',' ? *op : '\0') == *kp) {
#else
	while ((*op != ',' ? *op : NULL) == *kp) {
#endif
						/*   compare with key */
	    if (*kp++ == NULL)
		return (TRUE);			/*     found keyword */
	    op++;
	}
	while (*op != NULL && *op++ != ',') ;	/*   scan for next word */
    }
    return (FALSE);				/* keyword not found */
}

#ifdef TESTBED

#include <getparam.h>

string defv[] = {
    "opt=foo,bar,fum\n	String to an option from",
    "key=foo\n		Option, check if it's in the string",
    "VERSION=1.0a       11-sep-90 JEB/PTJ",
    NULL,
};

main(argc, argv)
int argc;
string argv[];
{
    string opt, key;

    initparam(argv, defv);
    opt = getparam("opt");
    key = getparam("key");
    printf("scanopt(\"%s\", \"%s\") returns %s\n",
	   opt, key, scanopt(opt, key) ? "true" : "false");
}

#endif
