#! /bin/csh  -f
#
#	import: 
#           Imports a tar file into an existing ABSOLUTE directory tree
#           Does a number of sanity checks, but is NOT fool proof yet.
#
#	21-mar-90	Created			Peter Teuben
#	29-mar-90	verbosity #files remaining	PJT
#
echo "IMPORT: Version 29-mar-90 PJT"
onintr int1_done
if ($#argv != 4) then
    echo "Usage: $0 tar-file absdir-name program mode"
    echo "Copies/Moves all files from a tar-file to a remote dir"
    echo "Directory structure on remote-dir must already exist"
    echo "  <tar-file>:      tar file"
    echo "  <absdir-name>:   directory (ABSOLUTE) where to put stuff"
    echo "  <program>:       program to use for copy"
    echo "  <mode>:          mode to copy/move the stuff"
    echo "      mode=0       all automatic"
    echo "      mode=1       plus user menu"
    exit 0
endif
set tar=$1
set remdir=$2
set program="$3"
set mode=$4

# echo "IMPORT> tar=$tar dir=$remdir program=$program mode=$mode"

if (! -e $tar) then
  echo "IMPORT Tar file $tar does not exist?"
  exit 0
endif

if (! -d $remdir) then
    echo "Directory root $remdir to import files into does not exist?"
    exit 0
endif


#       explode files in a temp directory
set tmp=tmp$$
mkdir $tmp
cd $tmp
onintr int2_done
echo "Exploding the tarfile, hang on..."
tar xf ../$tar
#       get list of files to work on
set files=(`find . -type f -print`)
set nfiles=$#files
#       process each file in that list
foreach file ($files)
  @ nfiles--
  echo -n "[$nfiles] $file :"
  set dir=$remdir/$file:h
  if (! -d $dir) then
    echo ""
    echo "Warning, directory $dir does not exist. Attempt to create it"
    mkdir $dir
    if ($status != 0) continue
    echo "    Created...cross your fingers"
  endif
  if ($mode) then
     cmp -s $file $dir/$file:t 
     if ($status == 0) then
        echo -n " Identical files - skipped"
        echo ""
        goto loop1_done
     else
        if (! -e $dir/$file:t) then
            echo " Warning: Destination does not exist"
        else
            echo ""
        endif
     endif
loop1:
     echo -n "Give option: [c]mp [d]iff [l]s [t]ype [q]uit [r]m [x]ecute [h]elp:"
     set ans=$<
     switch ($ans)
        case c*:
            cmp $file $dir/$file:t     
            breaksw
        case d*:
            diff $file $dir/$file:t | more
            breaksw
        case h*:
        case l*:
            ls -l $file $dir/$file:t     
            breaksw
        case q*:
            goto loop1_done
	case r*:
            rm $file
            goto loop1_done
        case t*:
            more $file 
            breaksw
        case x*:
	    # echo "IMPORT>> $program $file $dir"
            $program $file $dir
            chmod g+w $dir/$file:t
            goto loop1_done
        default:
            echo "Illegal option, try again:"
     endsw
     goto loop1
loop1_done:
  else
     cmp -s $file $dir/$file:t 
     if ($status == 0) then
        echo "Identical files .. skipped"
     else
        $program $file $dir
        chmod g+w $dir/$file:t
     endif
  endif
end
int2_done:
cd ..
int1_done:
echo "Now deleting temporary directory $tmp..."
rm -rf $tmp
echo "and renaming the imported tar file to $tar-"
mv $tar $tar-
