/*
 *  BMAP: remote transmitter...
 *
 *	arbitrarely advancing the clock ...
 */

#include <nemo.h>

string defv[] = {
    "source=test\n	Should be fixed as 'test'",
    "catalog=\n		Not used at the moment",
    "ants=\n		Antennae selection flag",
    "refants=\n		Non moving antennae",
    "fwidth=10\n	Total width the scan (arcmin)",
    "fstep=0.5\n	Step between scanlines (arcmin)",
    "vis=bmapdata\n	Output dataset",
    "ncalib=10\n	Calibrate every this many lines",
    "VERSION=0.3\n	20-aug-93 pjt",
    NULL,
};

string version="map antenna beam pattern on the remote transmitter";

nemo_main()
{
    real get_lst(), slew();
    string src, cat, name = getargv0();
    int ncalib = getiparam("ncalib");
    real dt, lst = get_lst();

    src = getparam("source");

    if (hasvalue("catalog")) warning("Ignoring catalog=%s",
		getparam("catalog"));
    if (!streq(src,"test")) warning("Source=%s is supposed to be 'test'",src);

    check_real_range("fwidth",getparam("fwidth"),1.0,60.0,"arcmin");
    check_real_range("fstep",getparam("fstep"),0.1,5.0,"arcmin");
    check_filename("vis",getparam("vis"));


    printf("%s: source=%s started at lst=%g\n",name,src,lst);

    lst += 5./60.0;     /* arbitrary 5 minute observation */

    set_lst(lst);
    printf("%s: stopped at lst=%g\n",name,lst);
}
