/* get_stop() : defunct since we only deal with getTime from original source */

#include <nemo.h>

local int getCommon();


/* local additions for checker: */

static int getCommon(name, def)
char *name;
int def;
{
    int n=1, value;
    char error[80];

    comgeti_(name, &value, &n, error);
    if (strncmp(error,"OK",2) != 0) {
        warning("reading common %s:\n  %s",name,error);
        return def;
    }
    if (n==0) return def;
    return value;
}

/* return TRUE if you cannot observe */

bool check_time(t)
real t;
{
    int istart, istop;
    real start, stop;
    
    istart = getCommon("pstart",0);    
    istop =  getCommon("pstop",0);    
    if (istart==0 && istop==0)  return FALSE;
    
    start = istart/100 + (istart%100)/60.0;
    stop = istop/100 + (istop%100)/60.0;

    if (stop < start) stop += 24.0;
    if (t < start) t += 24.0;
    return t >= stop;
}

