#include <nemo.h>

string defv[] = {
    "source=\n",
    "catalog=\n",
    "ants=\n",
    "itime=50\n",
    "nchan=\n",
    "vis=etcdata\n",
    "stepme=",
    "stepcen=",
    "stepsiz=",
    "stepn=",
    "trakopt=ch+\n",
    "device=\n",
    "times=-1,-1\n",
    "VERSION=1.2\n      20-aug-93 PJT",    
    NULL,
};

string usage="HatCreek ETC program stub";

nemo_main()
{
    real times[2];
    real get_lst();
    real lst = get_lst();
    int n;

    printf("ETC: source=%s started at lst=%g\n",getparam("source"),lst);
    n = nemoinpd(getparam("times"),times,2);
    if (n != 2) error("times= needs two values");
    check_source(getparam("source"),getparam("catalog"));
    check_filename("vis",getparam("vis"));
    
    if (times[0] < 0) {
        /* start observing now */
        if (times[1] < 0)
            lst += ABS(times[1]);
        else
            error("Cannot handle times(2) > 0");
    } else {
        error("Not implemented times(1)>0");
    }
    check_real_range("itime",getparam("itime"),1.0,3600.0,"seconds");
    check_int_range("nchan",getparam("nchan"),0,2048,"number of channels");
    



    set_lst(lst);
    printf("ETC: stopped at lst=%g\n",lst);
}
