/*
 * LSTSYMBOL: show and modify the LST time
 *		(modifying it can only be done in the checker mode)
 *
 *  2-jul-93  fixed inc (it was never implemented)  PJT
 * 20-oct     added 'mmmm' format (minutes since day) 0..1439
 * 27-jan-94  roundoff to nearest minute done properly	pjt
 */

#include <nemo.h>

string defv[] = {
    "lst=\n		New LST time if you want to reset the clock",
    "inc=\n             Increment LST time (decimal or hhmm)",
    "format=hhmm\n	hhmm, mmmm or other C printf() format specification",
    "VERSION=1.3\n      3-feb-94 PJT",    
    NULL,
};

string usage="HatCreek get or set the LST";

nemo_main()
{
    char fmt[100], *s, *show_lst();
    real lst, get_lst();
    int hh, mm, t;

    if (hasvalue("lst") || hasvalue("inc")) {   /* setting time */
        if (hasvalue("lst")) {
          if (strchr(getparam("lst"),'.'))  {     /* assume decimal hours */
            lst=getdparam("lst");
          } else {                                /* assume hhmm notation */
            t = getiparam("lst");
            lst = t/100 + (t%100)/60.0;
          }
        } else {
            lst = get_lst();			  /* get old time */
        }
        if (hasvalue("inc")) {
          if (strchr(getparam("inc"),'.'))  {     /* assume decimal hours */
            lst += getdparam("inc");
          } else {                                /* assume hhmm notation */
            t = getiparam("inc");
            lst += t/100 + (t%100)/60.0;
          }
        }
        set_lst(lst);
	dprintf(0,"LST reset to %s\n",show_lst(lst));
    } else {                                    /* getting time */
        strcpy(fmt,getparam("format"));
	if (streq(fmt,"hhmm")) {
            lst = get_lst();
            hh = (int) floor(lst);
            mm = (int) (0.5 + 60.0*(lst-hh));
            printf("%-04d\n",hh*100+mm);
	} else if (streq(fmt,"mmmm")) {
            lst = get_lst();
            hh = (int) floor(lst);
            mm = (int) (0.5 + 60.0*(lst-hh));
            printf("%d\n",hh*60+mm);
	} else {
            strcat(fmt,"\n");
            printf(fmt,get_lst());
        }
    }
}
