c= createcom
	program createcom
c& wh
c: common
c+
c	Createcom reinitializes the common block which contains all of
c	the shared variables for the Interferometer system.
c	The common pointers are reset to 0 and then the common is filled
c	with the values contained in the file $HATTAB/common.tab.
c	common.tab is formatted as follows:
c
c	!  blah blah  is a comment
c
c	A RECORD CONSISTS OF:
c	name(subscripts/datatype) /value/ [class] !comment
c	
c	 where:
c	 datatypes are I=integer*4 R=real*4  D=real*8
c	 classes are a=one per antenna  b=one per baseline
c		P=pointing  B=baseline  T=time  I=interferometer
c		C=correlator
c	
c	 Example:
c
c	 APC(6,9|R)	/0./		[Pa]	!azimuth pointing constants
c	 (Variable APC is a 6x9 array of Reals set to 0. in class Pointing)
c
c@ common
c	Name of the common block template. Default: $HATTAB/common.tab
c	Note: A local directory version is always tried before
c	the version in $HATTAB.
c--
c  unix->wh nov 90
c  mar92 wh - expand number of values for initialization to 400 chars tot
c  jun93 pjt - common block name is now an argument, trying local version
c		first, HATTAB later
c  jun94 pjt - extended filename length in 'buildcom'
c---------------------------------------------------------------------------c
	character version*(*)
	parameter(version='CREATECOM (version 1.2 11-jun-94)')
	character cname*80

	call output(version)
	call keyini
	call keya('common',cname,'common.tab')
	call keyfin

c  start exit handler to append log file
	call tidyexit

c  read COMMON.TAB, create and initialize the common variables;
c  this is Wilson's creation

	call buildcom(cname)
c
c  post notice in big and small log files

	call logit('CREATECOM - common variables reinitialized')
	stop
	end	
c
c BUILDCOM
c: observing
c+
	SUBROUTINE BUILDCOM(CNAME)
	CHARACTER CNAME*(*)

c  BUILDCOM:	reads the file hatshare:common.tab which is a 
c		template for the observing common block and uses 
c		this to construct the common block and hash table.
c--
c	nov 84  wh
c	nov 89  wh  -add extended initialization values on next line
c 	jun 93  pjt -  added CNAME parameter + search local file
c			before HATTAB file
c------------------------------------------------------------c
	character*80 line,error
	character*400 lineval
	character*1 type
	character*12 name
	character*1000 string
	character*4 numchar
	double precision dvalue(1000)
	real rvalue(1000)
	integer ivalue(1000)
	logical eof
	character*80 filename

c	--open the template file-- try local directory first
	open(10,name=cname,status='old',iostat=iostat,err=101)
	goto 102
  101   continue
	call filepath('HATTAB',cname,' ',filename)	
	open(10,name=filename,status='old',iostat=iostat,err=99)
  102   continue

c	--create a new common--
	call cominit

c	--read the template file/ decode each line/create and write
c	---the associated common variable--
	eof=.false.
	do while (.not.eof)
		read(10,'(a)',iostat=is,end=80) line

c	--ignore lines with ! in column 1--
		ic=index(line,'!')
		if(ic.ne.1) then		 

			ilp=index(line,'(')
			ico=index(line,',')
			ist=index(line,'|')
			isl1=index(line,'/')

c	--extract the appropriate fields from the line--
			name=line(1:ilp-1)
			if (ico-ilp.gt.0 .and. ico-ilp.lt.5) then
			  numchar=line(ilp+1:ico-1)
			  read(numchar,'(i3)') n1
			  numchar=line(ico+1:ist-1)
			  read(numchar,'(i3)') n2
		 	  num = n1*n2
			else
			  numchar=line(ilp+1:ist-1)
			  read(numchar,'(i3)',iostat=ios)  num
			end if

c  -- 	decode the value field and extended value field (next line)
			type=line(ist+1:ist+1)
			call get_value(line,lineval,nchar)

			if (type.eq.'C') then
			 string = ' '
			 read(lineval(:nchar),'(a)') string
			 call computa(name,string,num,error)
			 if(error(1:2).ne.'OK') type *,error

			else if (type.eq.'I') then
			 do i=1,num
			   ivalue(i)=0
			 end do
			 read(lineval,*,iostat=is) (ivalue(i),i=1,num)
			 call computi(name,ivalue,num,error)
			 if(error(1:2).ne.'OK') type *,error

			else if (type.eq.'R') then
			 do i=1,num
			   rvalue(i)=0.
			 end do
			 read(lineval,*,iostat=is) (rvalue(i),i=1,num)
			 call computr(name,rvalue,num,error)
			 if(error(1:2).ne.'OK') type *,error

			else if (type.eq.'D') then
			 do i=1,num
			   dvalue(i)=0.d0
			 end do
			 read(lineval,*,iostat=is) (dvalue(i),i=1,num)
			 call computd(name,dvalue,num,error)
			 if(error(1:2).ne.'OK') type *,error
			end if

		end if
		goto 82
80		eof=.true.
82		continue
	end do
	close (10)

	call cominfo(maxhash,lefthash,maxstore,next,error)
	type *
	type *,'Maxstore:',maxstore,'(next:',next,') Maxhash:',maxhash,
	1	'(empty:',lefthash,')'

	return
99	type *,'unable to find ',filename
	type *,'iostat =',iostat
	return
	end
c------------------------------------------------------------------c
	subroutine get_value(line,lineval,n)
	character*(*) line,lineval
	integer n,nslash

	lineval = ' '
	i = index(line,'/') + 1
	if (line(i:i).eq.'~') then
	  nslash = 0
	  do while (nslash.lt.2)
	   read(10,'(a)') line
	   i = index(line,'/')
	   if(nslash.eq.0 .and. i.gt.0) then
	     lineval = line(i+1:)
	     n = index(lineval,'/')
	     if(n.gt.0) then
		n = n-1
		nslash = 2
	     else
		n = len1(lineval)
		nslash = 1
	     end if
	   else if(nslash.eq.1 .and. i.gt.0) then
	     lineval = lineval(1:n)//line(1:i-1)
	     nslash = 2
	     n = len1(lineval)
	   else if(nslash.eq.1 .and. i.eq.0) then
	     lline = len1(line)
	     lineval = lineval(1:n)//line(1:lline)
	     n = len1(lineval)
	   else
	     type *,'error reading common.tab data line:'
	     type *,'>',line,'<'
	   end if
	  end do
	else
	  lineval = line(i:)
	  n = index(lineval,'/')-1
	end if
	return
	end
