c*
	PROGRAM VALUE
c& wh
c= VALUE  display values from common
c: program
c+
C  VALUE:	A command to display common block variables.
c
c
c@ name
c	The name of the variable to be displayed:  
c	NAME[-SUBS]  where SUBS is an optional subscript.
c	If name is an array and no subs is given, all
c	of the array will be displayed.
c@ op
c	h  for hours/min/secs from radians
c
c	d  for deg/min/secs from radians
c
c	o  prints integers as octal
c
c	x  prints integers as hex
c
c	s-i to produce a value multiplied by 10**i for use in
c	setting symbols using:
c
c	 setenv lab `value op=s-4 name=lab`
c--
C  unix-> nov 90  wh
c  nov 91 wh  - SORCDATA is special case
c  feb 94 wh  - error exit
c-------------------------------------------------------------------c
	include '../inc/constants.inc'
	include '../inc/ephem.inc'
	record /asource/ s
	character*14 angles
	character*80 error
	character*8 vlable
	character*1 type
	integer*4 numsub
	character*12 name,value*40
	real*4 number(1000)
	real*8 dnumber(1000)
	character*1000 string
	integer*4 inumber(1000)
	character*20 label,subsc,switches
	character*14 angra,angdec,angles

C	--DECODE LINE INTO SWITCH VALUES AND NAME(subscr)
	call keyini
	call keya('name',label,'')
	call keya('op',switches,' ')
	call keyfin

c --	multi== the symbol switch value
	ieq = index(switches,'-')
	if(ieq.gt.0) read(switches(ieq+1:ieq+2),'(I1)') multi

c  --	special case  SORCDATA
	if(label .eq. 'sorcdata') then
	  call comgeti('SORCDATA',S,24,error)
	   if(error(1:2).ne.'OK') goto 99
	  type *,'name: ',s.name,' at ticks:',s.tick
	  angra = angles(s.ra2000*12.d0/dpi)
	  angdec = angles(s.dec2000*180.d0/dpi)
	  type *,'ra(2000):',angra,' dec(2000):',angdec
	  type *,'ra0: ',s.ra0,'  ra1:',s.ra1
	  type *,'dec0:',s.dec0,'  dec1:',s.dec1
	  type *,'vsource: ',s.veloc,' vrest: ',s.vrest,' vsun: ',s.vsun
	  type *,'plmaj: ',s.plmaj,' plmin: ',s.plmin,' plangle: ',s.plangle
	  type *,'plflux: ',s.plfluxcr,' plbeam: ',s.plbeam,' pltb: ',s.pltb
	else
C  --	process a name
	if(index(label,'-').gt.0) then
		subsc = label(index(label,'-')+1:lnblnk(label))
		i = lnblnk(subsc)
		read (subsc,'(i<i>)') isubfirst
		isublast = isubfirst
		name = label(:index(label,'-')-1)
	else
		isubfirst = 0
		name = label(:lnblnk(label))
	end if
	
	CALL COMPROBE(NAME,TYPE,NUMSUB,ERROR)
		IF(ERROR(1:2).NE.'OK') goto 99

		IF(ISUBFIRST.EQ.0) THEN
		    ISUBFIRST = 1
		    ISUBLAST = NUMSUB
		    IF(TYPE.EQ.'C') ISUBLAST = 1
		ELSE IF(ISUBLAST.GT.NUMSUB) THEN
		    write(error,'(a,i4)')'subscript greater than ',NUMSUB
		    goto 99
		END IF

c  --	 read from common
		IF (TYPE.EQ.'I') THEN
			CALL COMGETI(NAME,INUMBER,NUMSUB,ERROR)
		ELSE IF (TYPE.EQ.'D') THEN
			CALL COMGETD(NAME,DNUMBER,NUMSUB,ERROR)
		ELSE IF (TYPE.EQ.'C') THEN
			CALL COMGETA(NAME,STRING,NUMSUB,ERROR)
		ELSE IF (TYPE.EQ.'R') THEN
			CALL COMGETR(NAME,NUMBER,NUMSUB,ERROR)
		END IF
			IF(ERROR(1:2).NE.'OK') goto 99

C	--output values--
	VLABLE = 'Value: '
	DO ISUBSCR=ISUBFIRST,ISUBLAST
	 IF (INDEX(SWITCHES,'s').EQ.0) THEN
		IF (TYPE.EQ.'C') THEN
		  VALUE = STRING(ISUBSCR:ISUBSCR+60)
		ELSE IF(INDEX(SWITCHES,'h').gt.0 .AND. TYPE.EQ.'D') THEN
		  VALUE = ANGLES(DNUMBER(ISUBSCR)*24.d0/DTUPI)
		ELSE IF(INDEX(SWITCHES,'d').gt.0 .AND. TYPE.EQ.'D') THEN
		  VALUE = ANGLES(DNUMBER(ISUBSCR)*360.d0/DTUPI)
		ELSE IF (TYPE.EQ.'D') THEN
		    WRITE(VALUE,'(1PD20.10)') DNUMBER(ISUBSCR)
		ELSE IF (TYPE.EQ.'R') THEN
		    WRITE(VALUE,'(F20.10)') NUMBER(ISUBSCR)
		ELSE IF (INDEX(SWITCHES,'o').gt.0 .AND. TYPE.EQ.'I') THEN
		    WRITE(VALUE,'(O15.1)') INUMBER(ISUBSCR)
		ELSE IF (INDEX(SWITCHES,'x').gt.0 .AND. TYPE.EQ.'I') THEN
		    WRITE(VALUE,'(Z10.1)') INUMBER(ISUBSCR)
		ELSE IF (TYPE.EQ.'I') THEN
		    WRITE(VALUE,'(I15.1)') INUMBER(ISUBSCR)
		END IF
	          TYPE 999,VLABLE,LABEL(:LNBLNK(LABEL)),'-',ISUBSCR,' = ',VALUE
999		  format(a,a,a,i3,a,a)
		VLABLE = '       '
	 ELSE 
		  IF(TYPE.EQ.'C') THEN
		    VALUE = STRING(ISUBSCR:ISUBSCR+MULTI)
		  ELSE IF(TYPE.EQ.'I') THEN
		    K=LOG10(MAX(10.,FLOAT(INUMBER(ISUBSCR))))+1.
		    WRITE(VALUE,'(I<K>.<K>)') INUMBER(ISUBSCR)
		  ELSE IF(TYPE.EQ.'D') THEN
		    IVALUE=INT(DNUMBER(ISUBSCR)*10.D0**MULTI)
		    K=LOG10(MAX(10.,FLOAT(IVALUE)))+1.
		    WRITE(VALUE,'(I<K>.<K>)') IVALUE
		  ELSE IF (TYPE.EQ.'R') THEN
		    IVALUE=INT(NUMBER(ISUBSCR)*10.**MULTI)
		    K=LOG10(MAX(10.,FLOAT(IVALUE)))+1.
		    WRITE(VALUE,'(I<K>.<K>)') IVALUE
		  END IF
		  TYPE *,VALUE
	 END IF
	END DO
	end if

99	if (error(1:2).ne.'OK') call bug('f',error)
	END
