C========================================================================
C				exports.inc
C========================================================================
C  Include file for Fortran users of cora export routines.
C========================================================================

C Spectra structure
	STRUCTURE /Spectra/
		INTEGER ants	! Antennas on-line, bit set for each.
		INTEGER mode	! Spectrometer mode, 1..4
		INTEGER ctype	! Type of correlation, 0=>Cross, 1=>Auto
		INTEGER mpx	! 0=>none, 1=>2X, 2=>4X multiplexing
		INTEGER han	! Whether to hanning-smooth the spectra
				! 0=>no,  1=>yes
		INTEGER process	! Processing flags, bit set for each:
				! 0=>norm, 1=>fixbadchan, 2=>fixclip,
				! 3=>window, 4=>halfshift,
				! 8=>FFT, 9=>fixbirdies, 10=>fixdelays,
				! 11=>aplpass, 12=>aplgain
		REAL corf(4)	! Correlator LO frequencies, MHz
		REAL corbw(4)	! Correlator band widths, MHz
		REAL shrate(2)	! Correlator processor shift rates, MHz
		INTEGER numants	! Number of antennas on-line
		INTEGER numbls	! Number of active correlators
		INTEGER numchans! Number of complex channels/spectrum
		REAL tint	! Integration time, seconds
		INTEGER blno	! Pointer to array of active BL identifiers
		INTEGER data	! Pointer to array of data[bl][chan],
				! chan=0..numchans-1, Complex data type.
	END STRUCTURE

C Fringes structure
	STRUCTURE /Fringes/
		INTEGER numbls	! Number of active correlators
		INTEGER blno	! Pointer to array of active BL identifiers
		INTEGER data	! Pointer to array of data[bl][sb],
				! bl = 0..numbls-1, sb = 0..1 (sideband).
				! Complex type.
	END STRUCTURE

C Procedures
	LOGICAL*4 cora_bank_flip!$pragma C( cora_bank_flip )
	LOGICAL*4 cora_comset	!$pragma C( cora_comset )
	LOGICAL*4 cora_cal	!$pragma C( cora_cal )
	LOGICAL*4 cora_passband	!$pragma C( cora_passband )
	LOGICAL*4 cora_get_lags !$pragma C( cora_get_lags )
	LOGICAL*4 cora_make_spectra !$pragma C( cora_make_spectra )
	EXTERNAL cora_msg	!$pragma C( cora_msg )
	EXTERNAL cora_start	!$pragma C( cora_start )
	EXTERNAL cora_idle	!$pragma C( cora_idle )
	LOGICAL*4 cora_test	!$pragma C( cora_test )
	EXTERNAL cora_wide	!$pragma C( cora_wide )
	EXTERNAL cora_writespectra !$pragma C( cora_writespectra )
	EXTERNAL cora_adc_power	!$pragma C( cora_adc_power )
	EXTERNAL coracom	!$pragma C( coracom )
	LOGICAL*4 cora_los	!$pragma C( cora_los )


