/*======================================================================*/
/*	mbus								*/
/*									*/
/*  Functions to access devices on the MultiBus I/O page.  Unix		*/
/*  dependent.  Mostly stolen from Wilson Hoffman, from his analogous	*/
/*  routines in "mbusio" written for Fortran users.			*/
/*======================================================================*/

/* Synonyms */
#define inpw mbus_inpw
#define outpw mbus_outpw
#define inpw_array mbus_inpw_array

/** mbus_open -- Open MultiBus for I/O operations			*/
/*:multibus								*/
/*+									*/
int mbus_open();		/* Returns 1=>happy 0=>otherwise	*/
				/* Reports errors on stderr stream.	*/
/*-									*/

/** mbus_inpw -- Input 16-bit word from given address on MultiBus	*/
/*:multibus								*/
/*+									*/
unsigned short int mbus_inpw	/* Returns data from multibus		*/
(	unsigned int addr );	/* in	MultiBus address		*/
/*-									*/

/** mbus_outpw -- Output 16-bit word to given address on MultiBus	*/
/*:multibus								*/
/*+									*/
void mbus_outpw
(	unsigned int addr,	/* in	MultiBus address		*/
	unsigned short int datum );
				/* in	Datum to be written to MultiBus	*/
/*-									*/

/** mbus_inpw_array -- Input an array of 16-bit words from MultiBus	*/
/*:multibus								*/
/*+									*/
void mbus_inpw_array
(	unsigned int addr,	/* in	MultiBus address		*/
	int nw,			/* in	Number of MultiBus 16-bit words	*/
	void * data);		/* out	Data read from MultiBus		*/
/*-									*/
