/***********************************************************************/
/*
 *  This file contains subroutines used by the scan and loop commands.
 *
 *  History:
 *    06jan94 jm  Extracted from scan.c and loop.c files.
 *    08mar94 jm  Added global variable AppDebug.
 *
 *---------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifndef TRUE
#define TRUE       1
#endif

#ifndef FALSE
#define FALSE      0
#endif

#define MAXBUF   256

#define Null '\0'

#ifdef __STDC__
#define ARGS(alist) alist
#else
#define ARGS(alist) ()
#define const /* NULL */
#endif /*__STDC__*/

#define FULLDAY 1440                             /* FULLDAY is 24h00m. */

#define ANDSYMBOL  ','
#define ORSYMBOL   '|'

#define isdelimiter(c) (((c) == ANDSYMBOL) || ((c) == ORSYMBOL))

typedef enum {ERROR = -1, NONE = 0, OKAY = 1} STATUS;

extern int AppDebug;

/* -- routine declarations -- */

extern void setProgram ARGS(( const char *name ));
extern void Warning ARGS(( FILE *fd, const char *format, ... ));
extern void Message ARGS(( FILE *fd, const char *format, ... ));
extern char *skipLeading ARGS(( const char *token ));
extern char *getGroup ARGS(( const char *token, char *group ));
extern void freeVariables ARGS(( void ));
extern int loadVariables ARGS(( const char *filename, const char *project, int nest ));
extern char *getVariable ARGS(( const char *task, const char *name ));
extern int setCurrentLST ARGS(( void ));
extern unsigned int getCurrentLST ARGS(( void ));
extern char *formatTime ARGS(( void ));
extern unsigned int getTime ARGS(( const char *string, unsigned int defTime ));
extern int checkTime ARGS(( unsigned int offset ));
extern int checkLoopSrcTime ARGS(( unsigned int src, unsigned int cal, unsigned int thresh ));
extern int setTimes ARGS(( const char *starttime, const char *stoptime ));
extern char *getTaskName ARGS(( const char *varName ));
extern STATUS doScan ARGS(( const char *setup, FILE *fd, const char *project ));
