//==========================================================================
//  telefun -- Miscellaneous telescope functions used by correlator stuff.
//		These are "fronts" for the real routines, which appear
//		in the receiver functions.
//==========================================================================

#ifndef TELEFUN_H
#define TELEFUN_H

enum FlapState{ Sky, Ambient, Hot };
const int NANTENNAS = 9;	// Current possible # ants, allowed for
				// by Global Common
int tele_setflaps(		// Set flaps
	int	ants,		// in	Antennas on-line bitmap
	FlapState state );	// in	New state to set the flaps to
int tele_get_altaz(		// Read encoders for altitude, azimuth
	int	antno,		// in	Logical antenna number, 0..11
	float & alt,		// out  Altitude, degrees
	float & az );		// out  Azimuth, degrees
double tele_lo1();		// Fetch 1st LO freq.
double tele_lo2();		// Fetch 2nd LO freq.
float tele_outdoor_temp(	// Get outdoor temperature
	int ant);		// in	Logical antenna number, 0..11
float tele_total_power(		// Get receiver total IF power
	int antno );		// in	Antenna slot number, 0..11


#endif // TELEFUN_H
