c
c* CATALOG_POSITION
c: ephemeris
c+
	SUBROUTINE CATALOG_POSITION(TJD,SOURCE,CATALOG,S,ERROR)

C  CATALOG_POSITION:	Find positions for stellar sources in catalogs.

c  ARGUMENTS:
c  TJD (dp,input)		Julian date/time
c  SOURCE (char,input)		Source name
c  CATALOG (char,input)		Catalog name (none for planets)
c  S (RECORD,output)		RECORD containing source parameters
c  ERROR (char,output)		Status return
c--
C	MAR 85  WH
C	nov 89  wh
c	unix-> wh nov 90
c	sep 93 wh   expand catalog
C--------------------------------------------------------C
	include '../../inc/constants.inc'
	include '../../inc/catalog.inc'
	include '../../inc/ephem.inc'
	record /asource/ s
	record /catalog_entry/ cat
	real*8 tjd
	real*4 vear
	character*10 source
	character*100 catalog
	character*80 error


	CALL SEARCH_CATALOG(SOURCE,CATALOG,CAT,ERROR)

	IF(ERROR(1:2).NE.'OK') RETURN

C	----GET APPARENT POSITION----
	S.RA2000 = CAT.RA *DPI/12.D0
	S.DEC2000 = CAT.DEC *DPI/180.D0

C --  calculate for desired time
C --   (hr/deg in and rad out)
	CALL APSTAR(TJD, CAT.RA,CAT.DEC, CAT.PMRA,CAT.PMDEC, 0.D0,0.D0,
	1			S.RA0,S.DEC0,S.VSUN,S.VREST, ERROR)
	 IF(ERROR(1:2).NE.'OK') RETURN

c --  ra1, dec1 are typically 10e-6 radians per radian of time so
c --   can be 0. over the period of 1 integration.
	S.RA1=0.d0
	S.DEC1=0.d0

C  --  fill in velocities and planet stuff 
	S.VELOC = CAT.VEL
	S.PLMAJ = 0.
	S.PLMIN = 0.
	S.PLANGLE = 0.
	S.PLFLUXCR = 0.
	S.PLTB = 0.
	S.PLBEAM = 0.
	RETURN
	END
