c
c* SEARCH_CATALOG
c: observing
c+
	SUBROUTINE SEARCH_CATALOG(SOURCE,CATALOG,CATOUT,ERROR)
C
C  SEARCH_CATALOG:	Search through a catalog file for given source
C			and return its j2000 position/velocity.
C			(used by EPHEMERIS::CATALOG_POSITION)
c			Note: if catalog is left blank j2000.cat
c			is filled in before we get here.
c
c  ARGUMENTS:
c  SOURCE (char*8,input)	Name of source
c  CATALOG (char,input)		Name and directory of catalog 
c  ERROR (char,output)		Status return
c--
C	nov 89 wh
C	DEC 89 WH - REUSE OLD ENTRY IF POSSIBLE
c	unix-> nov 90 wh
c       23-jun-93  pjt  - made longer catpath*80 and included this in
c			  error message
c	29-jul-93  wh   - fixed bug introduced by ^, check j2000 also		
c			- add check for cat in local directory
c	sep93 wh 	- expand lastcat
c	sep94 wh	- search UCAT/catalog before HATCAT/catalog
c	sep94 pjt	- liberal declaration of source,catalog
c----------------------------------------------------------------------c
	character*(*)source,catalog
	character*80 error
	character*100 catpath,gee
	character*12 match
	character*100 lastcat
	include '../../inc/catalog.inc'
	record/catalog_entry/ cat,catout

C  --  if the same source is requested, give the same answer
	ERROR = 'OK'
	MATCH = SOURCE
	IF ((MATCH.NE.CAT.NAME).OR.(CATALOG.NE.LASTCAT)) THEN
	  lastcat = catalog
	  close(12)
c  --	try to open catalog as it is typed in:
	  OPEN (unit=12, file=catalog(:len1(catalog)), status='old', 
	1	access='direct', form='unformatted',
	3	recl=80, iostat=is)
c  --	if this fails, try to open $UCAT/catalog
	  if (is.ne.0) then
	   L2 = len1(catalog)
	   L1 = L2
	   DO WHILE((L1.gt.1).and.(CATALOG(L1-1:L1-1).ne.'/'))
		L1 = L1-1
	   END DO
	   CALL FILEPATH('UCAT',catalog(L1:L2),' ',catpath)
	   OPEN (unit=12, file=catpath(:len1(catpath)), status='old', 
	1	access='direct', form='unformatted',
	3	recl=80, iostat=is2)
c  --	if this fails, try to open $HATCAT/catalog
	   if (is2.ne.0) then
	    CALL FILEPATH('HATCAT',catalog(L1:L2),' ',catpath)
	    OPEN (unit=12, file=catpath(:len1(catpath)), status='old', 
	1	access='direct', form='unformatted',
	3	recl=80, iostat=is3)
c  --	if this also fails, error return
	    if (is3.ne.0) then
		call gerror(gee)
		lp2 = len1(catpath)
		lp1 = max(1,lp2-15)
		error = 'Search: '//gee(1:len1(gee))//' '//
	1					catpath(lp1:lp2)
		return
	    end if
	   end if
	  end if
c  --	lookup source in whatever catalog worked
	  CALL CATFIND(SOURCE,'GET',CAT,ERROR)
	END IF

	CATOUT = CAT

	RETURN
	END
