c
c* CATFIND
c: catalog
c+
	SUBROUTINE CATFIND(SOURCE,ACTION,ENTRYOUT,ERROR)

c	CATFIND:	search a catalog file for SOURCE. The file has
c			been previously opened. 
c	ARGUMENTS:
C	SOURCE(char,input)	Name of source to find
c	ACTION(char,input)	'Enter' means enter the source in the cat
C				'CHANGE'means change an existing entry
c				'Get'   means retrieve the entry
c				'Delete'means delete an entry
c	ENTRYOUT(record,output)	The record holding the information
c	ERROR(char,output)	Status return
c--
C	APR 79  WH
C	JAN 83  WH  CHANGE TO RADIX 2 SEARCH
C	JUN 85  CHANGE TO VAX
c	unix-> nov 90 wh
c----------------------------------------------------------------c
	include '../../inc/catalog.inc'
	character*8 source
	character*10 action
	record /catalog_entry/ entry,entryout
	record /catalog_first/ head
	character*80 error,gerror
	integer i,ifir,ilas

C  --   the first record of the catalog contains the number of entries
	READ(12'1,IOSTAT=IS) HEAD
	IF(IS.NE.0) THEN
	  ERROR = 'FIND: '//GERROR()
	  RETURN
	END IF

C  --	come here if the catalog is empty: iend=1
	IF(HEAD.IEND.EQ.1) THEN
	  IF(ACTION(1:1).EQ.'E') THEN
	    WRITE(12'2) ENTRYOUT
	    HEAD.IEND = 2
	    WRITE(12'1) HEAD
	    ERROR = 'OK'
	  ELSE
	    ERROR = 'FIND: catalog is empty'
	  END IF	
	  RETURN
	END IF
	
	IFIR=2
	ILAS=HEAD.IEND
1	I=(IFIR+ILAS)/2
	READ(12'I) ENTRY

	IF(ENTRY.NAME.EQ.SOURCE) GO TO 10

	IF(ENTRY.NAME.GT.SOURCE) GOTO 8

	I=I+1
	IFIR=I
	GOTO 9

8	ILAS=I-1

9	IF(IFIR.LE.ILAS) GO TO 1

c  --	this is where we come if there is no match
	IF(ACTION(1:1).EQ.'E') THEN
	  DO J=HEAD.IEND,I,-1
	    READ(12'J) ENTRY
	    WRITE(12'J+1) ENTRY
	  END DO
	  WRITE(12'I) ENTRYOUT
	  HEAD.IEND = HEAD.IEND + 1
	  WRITE(12'1) HEAD
	  ERROR = 'OK'
	ELSE
	  ERROR = 'FIND: source '//source//' doesn''t exist'
	END IF	
	RETURN
	
C  --	this is where we come if we have a match
10	IF(ACTION(1:1).EQ.'E') THEN
	  ERROR = 'FIND: source '//source//' already exists'
	ELSE IF (ACTION(1:1).EQ.'C') THEN
	  ERROR = 'OK'
	  WRITE(12'I) ENTRYOUT
	ELSE IF (ACTION(1:1).EQ.'D') THEN
	  DO J=I,HEAD.IEND-1
	    READ(12'J+1) ENTRY
	    WRITE(12'J) ENTRY
	  END DO
	  HEAD.IEND = HEAD.IEND - 1
	  WRITE(12'1) HEAD
	  ERROR = 'OK'
	ELSE
	  ERROR = 'OK'
	  ENTRYOUT = ENTRY
	END IF	
	RETURN
	END

