c
c* JULIAN
c: 
c+
	DOUBLE PRECISION FUNCTION JULIAN(IDY,MON,IYEAR,UT)

C  JULIAN:	calculate the julian day number from the date
c		and UT1.
c
c  ARGUMENTS:
c  IDY (integer,input)		Day
c  MON (integer,input)		Month
c  IYEAR (integer,input)	Year
C  UT (dp,input)		Universal time (radians)
c--
C	REDONE MAR 85  WH
c	unix-> nov 90 wh
c----------------------------------------------------------------c
	include '../../inc/constants.inc'
	integer idy,mon,iyear
	double precision ut
	real*4 damon(12)
	data damon/0.,31.,59.,90.,120.,151.,181.,212.,243.,273.,304.,
	1  334./

	IYR=MOD(IYEAR,1900)
	YEARD=DAMON(MON)+IDY
	LIND=MOD(IYR,4)
	IF((LIND.EQ.0).AND.(MON.GT.2)) YEARD=YEARD+1.
	LPYRS=IYR/4
	IF(LIND.EQ.0) LPYRS=LPYRS-1
	JULIAN=2415019.5D0+DBLE(YEARD)
	JULIAN=JULIAN+DBLE(FLOAT(IYR))*365.D0
	JULIAN=JULIAN+DBLE(FLOAT(LPYRS)) + (UT/DTUPI)
	RETURN
	END
