c
c* XSTRLFLT
c: observing
c+
	REAL*8 FUNCTION XSTRLFLT (TXT,ERROR)
c
c  XSTRLFLT:	Convert text string to long floating point. String may 
c		be integer constant, floating F or G format, with or without
c		decimal, or Babylonian ddd:mm:ss.sss.  Sign in first char.
c		pos. OK. Entire string is used.  (Use TOKEN function to 
c		strip numbers from text.)
c
c  ARGUMENTS:
c  TXT (char,input)	input text string
c  ERROR (char,output)	Status return
c--
c	apr 86  wh   error return added
c-------------------------------------------------------------------------
	  implicit	none

	  CHARACTER*(*)	txt,error
c---------------------------------------------------------------------------
	  CHARACTER*40  text
	  INTEGER	L, m, h, n, x_string_integer, xp, signx
	  REAL*8	sign, s, um, x_string_lfloat
c---------------------------------------------------------------------------
	  error='OK'
	  text = txt
	  do while (((text(1:1) .eq. ' ') .or. (ichar(text(1:1)) .eq. 9))
	1	.and. (text .ne. ' '))
	    text = text(2:)
	  end do
	  if (text(1:1) .EQ. '-') then
	    sign = -1.0
	    text = text(2:)
	  else if (text(1:1) .EQ. '+') then
	    sign = 1.0
	    text = text(2:)
	  else
	    sign = 1.0
	  endif
	  L = LEN(text)
	  DO WHILE ((L .GT. 0) .AND.
	1	( (text(L:L) .EQ. ' ') .or. (ichar(Text(L:L)) .eq. 0) ))
	    L = L - 1
	  ENDDO
	  IF (L .EQ. 0) THEN
	    Xstrlflt = 0.0D0
	  ELSE
	    if (L .GT. 39) L = 39
	    text(L+1:L+1) = char(0)
	    n = index(text, ':')
	    if (n .eq. 0) then
	      n = index(text, 'E')
	      if (n .eq. 0) n = index(text, 'e')
	      if (n .eq. 0) then
	        xstrlflt = x_string_lfloat(L,text,error)
		if(error.ne.'OK') return
	      else
	        n = n - 1
	        um = x_string_lfloat(n,text,error)
		 if(error.ne.'OK') return
	        text = text(n+2:)
	        if (text(1:1) .eq. '-') then
	          signx = -1
	          text = text(2:)
	        else if (text(1:1) .eq. '+') then
	          signx = 1
	          text = text(2:)
	        else
	          signx = 1
	        end if
	        n = index (text, char(0))
	        n = n - 1
	        xp = x_string_integer (n, text,error)
	 	if(error.ne.'OK')return
	        xstrlflt = um * 10.0D0**(signx*xp)
	      endif
	    else
	      n = n - 1
	      h = x_string_integer (n, text,error)
		if(error.ne.'OK') return
	      text = text(n+2:)
	      n = index(text, ':')
	      if (n .ne. 0) then
	        n = n - 1
	        m = x_string_integer (n, text,error)
		if(error.ne.'OK')return
	        if (m .gt. 60)
	1	  error= 'XSTRLFLT--Questionable Babylonian conversion '//txt
	        text = text(n+2:)
	        n = index(text, char(0))
	        n = n - 1
	        s = x_string_lfloat (n, text,error)
	 	 if(error.ne.'OK') return
	        if (s .gt. 60.0D0)
	1	  error='XSTRLFLT--Questionable Babylonian conversion '// txt
	        xstrlflt = h + dble(m)/60.0D0 + s/3600.0D0
	      else
	        n = index(text, char(0))
	        n = n - 1
	        um = x_string_lfloat (n, text,error)
	 	if(error.ne.'OK') return
	        if (um .gt. 60.0D0)
	1	  error='XSTRLFLT--Questionable Babylonian conversion '// txt
	        xstrlflt = h + um/60.0D0
	      end if
	    end if
	    xstrlflt = xstrlflt*sign
	  ENDIF
	END

	real*8 function x_string_lfloat (n, str,error)
	  integer	n
	  character*40	str
	  character*(*) error

	  integer	i
	  logical	Digit, dot

	  dot = .false.
	  do i=1,n
	    if (str(i:i) .eq. '.') then
	      if (dot) then
	        error='X_STRING_LFLOAT -- illegal input ' // str
	        X_STRING_LFLOAT = 0.0D0
	        return
	      end if
	      dot = .true.
	    else
	      if (.not. Digit(str(i:i))) then
	        error= 'X_STRING_LFLOAT -- illegal input ' // str
	        X_STRING_LFLOAT = 0.0D0
	        return
	      end if
	    end if
	  end do
	  decode (n, 101, str) x_string_lfloat
101	  format (g40.0)
	  return
	end
	integer function x_string_integer (n, str,error)
	  integer	n
	  character*(*) error
	  character*40	str

	  integer	i
	  logical	Digit

	  x_string_integer = 0
	  do i=1,n
	    if (.not. Digit(str(i:i))) then
	      error='X_STRING_INTEGER -- illegal input ' // str
	      return
	    end if
	  end do
	  if (n .eq. 0) return
	  decode (n, 101, str) x_string_integer
101	  format (i<n>)
	  return
	end
	logical function digit(ch)
	  character*1 ch

	  ich=ichar(ch)
	  if((ich.ge.'60'o).and.(ich.le.'72'o)) then
	    digit=.true.
	  else
	    digit=.false.
	  end if
	  return
	end
