c
c* CALCUNSVNS
c: observing
c+
	SUBROUTINE CALCUNSVNS(LST,U,V,ERROR)
c
c  CALCUNSVNS:	 calculates u and v at the given lst for all antennas
c		 using the antenna positions from common
c
c  ARGUMENTS:
c  LST (dp,input)	Local Siderial Time
c  U(),V() (dp,output)	Baseline Projections
c  ERROR(char,output0	Status return
c--
c	may 86  wh
c	unix-> wh nov 90
c----------------------------------------------------------------c
	implicit real*8 (a-h,o-z)
        include '../../inc/constants.inc'
	real*8 		lst			!siderial time (in)
	real*8		u(nants),v(nants)	!u and v (ns)  (out)
	character error*80
        real*8 ra,dec,h,cosh,sinh,sind,antpos(nants,3)

	CALL COMGETD('RA',RA,1,ERROR)
	CALL COMGETD('DEC',DEC,1,ERROR)
         if(error(1:2).ne.'OK') return
	H=LST-RA
	COSH=COS(H)
	SINH=SIN(H)
	SIND=SIN(DEC)
        CALL COMGETD('ANTPOS',ANTPOS,3*NANTS,ERROR)
         if (error(1:2).ne.'OK') return
        DO I=1,NANTS
	 BXX=ANTPOS(I,1)
	 BYY=ANTPOS(I,2)
	 BZZ=ANTPOS(I,3)
	 U(I)=(BXX*SINH+BYY*COSH)
	 V(I)=(-BXX*SIND*COSH+BYY*SIND*SINH+BZZ*COS(DEC))
        END DO
	RETURN
	END
