/** TIDY	- clean up						*/
/*: misc								*/
/*+
	TIDY (called from exit)
  TIDY:		is the exit handler that is run after all programs
		and cleans up: stops the antenna tracking, 
		unlocks all resources.

									*/
/*--  23jul93 wh  blank the program common variable			*/
/*--  10jun94 pjt solaris patch for checker only !!! 			*/
/*	  none of this code actually does something useful in checker	*/
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include "hatlib.h"

#ifdef SOLARIS
void tidy2();
#else
void tidy2(int,int,struct sigcontext *,char *) ;
#endif

void tidy()
{
  int pid, i ;
  int one = 1 ;
  int four = 4 ;
  int nine = 9 ;
  int zero = 0 ;
  double dzero = 0. ;
  int lockfreq,locksrc,lockcor,lockant[9],someant ;
  int itrack[9] ;
  double dazim[9], delev[9] ;
  char error[80], out[10], program[64] ;
  int d64 = 64 ;
  double rais = 2. ;

	computd_("RA",&rais,&one,error) ;
	pid = getpid() ;
	someant = 0 ;
	comgeti_("LOCKFREQ",&lockfreq,&one,error) ;
	comgeti_("LOCKSRC",&locksrc,&one,error) ;
	comgeti_("LOCKCOR",&lockcor,&one,error) ;
	comgeti_("LOCKANT",lockant,&nine,error) ;
	comgeti_("ITRACK",itrack,&nine,error) ;
	comgetd_("DAZIM",dazim,&nine,error) ;
	comgetd_("DELEV",delev,&nine,error) ;

	if (lockfreq == pid) computi_("LOCKFREQ",&zero,&one,error) ;
	if (locksrc == pid) computi_("LOCKSRC",&zero,&one,error) ;
	if (lockcor == pid) computi_("LOCKCOR",&zero,&one,error) ;

	for (i=0; i<9; i++) {
	  if (lockant[i] == pid) {
	    lockant[i] = 0 ;
	    someant = 1 ;
	    itrack[i] = 0 ;
	    dazim[i] = 0. ;
	    delev[i] = 0. ;
	  }
	}
	computi_("LOCKANT",lockant,&nine,error) ;
	computi_("ITRACK",itrack,&nine,error) ;
	computd_("DAZIM",dazim,&nine,error) ;
	computd_("DELEV",delev,&nine,error) ;

	if (someant) {
	  computd_("DRA",&dzero,&one,error) ;
	  computd_("DDEC",&dzero,&one,error) ;
	}
	for(i=0;i<63;i++) program[i] = ' ' ;
	program[63] = '\0' ;
	computa_("PROGRAM",program,&d64,error) ;

	printf("Common OK.\n") ;
}
/** TIDY2	- clean up after signals 				*/
/*: misc								*/
/*+
	TIDY2 (called by signals)
  TIDY2:	is the exit handler that is run after signals
		and cleans up by calling TIDY and also displays
		the affending signal
									*/
/*--									*/
#ifdef SOLARIS
void tidy2()
{
}
#else
void tidy2(int sig,int code,struct sigcontext *scp,char *addr)
{
	signal(SIGHUP,SIG_DFL) ;
	signal(SIGINT,SIG_DFL) ;
	signal(SIGQUIT,SIG_DFL) ;
	signal(SIGILL,SIG_DFL) ;
	signal(SIGABRT,SIG_DFL) ;
	signal(SIGIOT,SIG_DFL) ;
	signal(SIGFPE,SIG_DFL) ;
	signal(SIGBUS,SIG_DFL) ;
	signal(SIGSEGV,SIG_DFL) ;
	signal(SIGSYS,SIG_DFL) ;
	signal(SIGTERM,SIG_DFL) ;
	signal(SIGLOST,SIG_DFL) ;
	signal(SIGTSTP,SIG_DFL) ;
	psignal(sig,"Program dies because of ") ;
	exit(0) ;
}
#endif
/** TIDYEXIT	- install clean up routine				*/
/*: misc								*/
/*+
	CALL TIDYEXIT
  TIDYEXIT:	installs the exit handler that is run after observing
		programs to reset certain common block variables.
		
									*/
/*--									*/
int tidyexit_()
{
  caddr_t arg ;
  int ret ;
#ifndef SOLARIS
	ret = on_exit(tidy,arg) ;
	signal(SIGHUP,tidy2) ;
	signal(SIGINT,tidy2) ;
	signal(SIGQUIT,tidy2) ;
	signal(SIGILL,tidy2) ;
	signal(SIGABRT,tidy2) ;
	signal(SIGFPE,tidy2) ;
	signal(SIGBUS,tidy2) ;
	signal(SIGSEGV,tidy2) ;
	signal(SIGSYS,tidy2) ;
	signal(SIGTERM,tidy2) ;
	signal(SIGLOST,tidy2) ;
	signal(SIGTSTP,tidy2) ;
	signal(SIGCHLD,SIG_IGN) ;
#endif
}
