#! /bin/csh -f
#
#    Observing Script Example 1 - july 1993	   !!! unfinished prototype !!!
#    3dec93: some adaptations, but still bad example.
#    Single Source Calibrator plus Passband observation
#
#    ===> Please, if you modify this template, put your own name / 
#    ===> comments here, and remove these lines.
#    ===> change the 'EDIT', but leave the 'FIX' parts alone 

# announce
 echo "**********************************************************"
 echo "       example1.csh  (version 3dec93 - pjt) "
 echo "**********************************************************"

# set default commandline keywords                                     <=== EDIT
 set ants=134567
 set planet=mars
 set integ=60
# unset required variables (done merely for clarity here) and set minarg <= EDIT
# we prefer minarg to be 0 though, i.e. no 'unset' variables.
 unset stop
 unset project
 set minarg=2

# test for the correct (minimum) number of arguments (# unset's above)  <=== FIX
 if ($#argv < $minarg) goto usage
 if ($1 == help) goto usage

# parse commandline arguments (assumed to be of key=val type)           <=== FIX
 foreach a ($*)
  set check=`echo $a | awk -F= '{print NF}'`
  if ( "$check" > 1 ) then
    set $a
  else
    echo "### Warning: skipping argument $a; not constructed as key=val"
    # here you could also 'exit' or 'goto usage'
  endif
 end

# setup start-stop logic                                                <=== FIX
 set start=`lstsymbol`
 set logic='&&'
 if ($start < $stop) set logic='||'
 alias if_timesup 'set lst=`lstsymbol`;if($lst>$stop $logic $lst<$start) \!*'

# define useful things: shell variables and aliases                    <=== EDIT
 set date=`hatdate`
 alias scan "int ants=$ants itime=$integ"
 alias isup "checksource elevlim=12 setme=visible"
 set pbdone=no
 set source=3c84
 set cal=3c273
 set work=$DATA/$project/$date

# optional: you can echo the required (or all) keywords -> error trap  <=== EDIT
 echo stop=$stop project=$project > /dev/null

#
# Observing Can Commence =======================================================
#

# some questionable, but needed startups

 echo Working directory in $work
 mkdir -p $work ; cd $work
 unlock

# Set up the frequency and correlator

 setfreq freq=86.243 iffreq=150.0 source=$source
 setcorr cormode=4 corbw=100,100 corf=175,375,575,775 ants=$ants

# Try and observe the planet first (another try occurs after src/cal loop)

 set isup=`isup source=$planet`
 if ( "$isup" == "y" ) then
   scan source=$planet vis="$planet.$date" times=-1,-0.4
   set pbdone=yes
   echo "Finished observing $planet BEFORE"
 endif

# Begin source/cal cycle; quit when either has set or stoptime has reached

 while (1)
    if_timesup break

    set cisup=`isup source=$cal`
    set sisup=`isup source=$source`
    if ( "$cisup" != "y"  ||  "$cisup" != "y" ) break

    scan source=$cal   vis="$cal.$date"     times=-1,-0.1
    scan source=$source vis="$source.$date" times=-1,-0.4

 end

# Final calibration observation (let's hope $cal is still up...)

 set isup=`isup source=$cal`
 if ( "$isup" == "y") then
    scan source=$cal   vis="$cal.$date"     times=-1,-0.1
 else
    echo "Too bad, your calibrator $cal was set. Last scan may be hard to calibrate"
 endif

# If planet had not been up earlier, try again, followed by final check

 if ( "$pbdone" == "no") then
    set isup=`isup source=$planet`
    if ( "$isup" == "y" ) then
      scan source=$planet vis="$planet.$date" times=-1,-0.4
      echo "Finished observing $planet AFTER"
      set pbdone=yes
    endif
 endif
 if ( "$pbdone" == "no") then
    echo "### Warning: never did the passband on planet $planet"
 endif

 echo "Finished observing source=$source"
 exit 0

#
# End of observing ============================================================
#

# 
# Usage message, with a safety exit before usage 
#
  exit 0
usage:                                                                 <=== EDIT
  echo "Usage: $0 [ants=$ants] [planet=$planet] [integ=$integ] "
  echo "          project=test stop=0120" 
  echo "Example single source + calibrator plus passband observing"
  echo "	[P_b] { (S,C) ... } C [P_a]"
  exit 0


